_ = require 'underscore'
coffee = require './portable-coffee-script/index'
# {events} = modules

#log = console.log unless log?

print_call_stack = ->
  stack = new Error().stack
  console.log "PRINTING CALL STACK"
  console.log stack

# ---dependent functions (of CCNode)---
# ... addChild (essential)
# ... setVisible (for implement show prop)


# reserved at template
reservedProps = [
	'type',
	'bind',
	'template'
	'children'
	'repeat'
	'show'
#	'id'
	'priority'
]


to_arr = (arg) ->
	if _.isString arg
		arg.split(' ').map (c) -> parseFloat c
	else
		arg

slice_first_char = (string) ->
	unless typeof string == 'string'
		nothing = string
		nothing
	else
		string.substr(1, string.length-1)

randomId = ->
	Math.floor(Math.random() * 9007199254740992)


# return a function that return evaluated
makeFunc = (str) ->
	contents = [
		'return ->'
		"  return (#{str})"
	].join('\n')
	func_str = coffee.compile contents
	fn = null
	eval('fn = ' + func_str)

	(scope) ->
#		log 'scope : ', scope.$$controllerName
#		if scope.$$controllerName == 'AppCtrl'
#			do print_call_stack
#		log String(fn)
		cur = fn.call(scope)
#		log cur
		cur


# return a function that return interpolated str
interpolate = (str) ->
	return (-> str) if (typeof str) != 'string'
	resArr = []
	recent = 0
	str.replace /{{([^}]+)}}/g, (match, p1, offset, string) ->
		if recent < offset 
			resArr.push str.substr recent, offset - recent
		recent = offset + match.length
		resArr.push makeFunc(p1)
		''

	if recent < str.length
		resArr.push str.substr recent, str.length - recent

	(scope) ->
		something = null
		for mola in resArr
			if typeof mola == 'string'
				ala = mola
			else if typeof mola == 'function'
	#			log 'in the interpolation'.bold
				ala = mola scope
			else
				throw 'unrecognized type of mola : ' + typeof mola

			unless something?
				something = ala
			else
				something += ala

		something

innerApply_r = ($scope) ->
	changed = false

	for w in $scope.$$watches
#		log 'gonna get value from targetFunc with scope : ', $scope
		$scope[w.repeated.itr] = $scope[w.repeated.container][w.repeated.index] if w.repeated?

		cur = w.targetFunc $scope
		if (_.isArray cur) and (_.isArray w.prev)
			res = cur.length == w.prev.length
		else
			cur_str = JSON.stringify(cur)
			res = w.prev_str == cur_str

		if not res
			w.listener.call($scope, cur, w.prev)
			w.prev = _.clone cur
			w.prev_str = cur_str
			changed = true

	_.reduce $scope.$$childScopes, ((memo, s) -> innerApply_r(s) or memo), changed
	
genScope = (parentScope) ->
	Scope = ->
	Scope.prototype = parentScope

	$scope = new Scope()
	$scope.$$childScopes = []
	$scope.$$watches = []

	is_root_scope = true if parentScope == null

	if is_root_scope
		$scope.$$rootScope = $scope
#		$scope.$$elements = {}
	else
		parentScope.$$childScopes.push $scope
		$scope.$$rootScope = parentScope.$$rootScope

	$scope.$$watch = (targetFunc, listener, repeated) ->
		$scope.$$watches.push
			targetFunc: targetFunc
			listener: listener
			prev: null
			prev_str: ''
			repeated: repeated
	 	
	$scope.$apply = (fn) ->
		fn?()
		loop
			break unless innerApply_r $scope
		null

	$scope.$$removeFromParent = ->
		parentScope.$$childScopes = _.reject parentScope.$$childScopes, (cs) -> cs == $scope

	$scope

getManagedProps = (template) ->
	results = []
	for name of template
		prop = template[name]
		if not _.contains reservedProps, name
			results.push name
	results

module.exports = (dicts...) ->
	# make a appropriate drwable object dictionary...
	# compose dictionaries to one dictionary
	if dicts == null or dicts.length == 0
		dict = []
	else
		dict = dicts[0]
		dict = _.extend dict, dict[i] for i in [1...dicts.length]
	

	pub = {}

	pub.include = (newDict) ->
		dict = _.extend dict, newDict

	# traverse node
	# if node has controller... create scope
	createScope_r = (template, parentScope, controllers) ->
		is_root_scope = true unless parentScope
		node_has_scope = true if template.controller

		throw 'root node must have a controller' if is_root_scope and not node_has_scope

		if node_has_scope
			scope = genScope parentScope
			ctrl = controllers[template.controller]
			ctrl scope
			scope.$$controllerName = template.controller
		else
			scope = parentScope

		if template.children?
			for child in template.children
				createScope_r child, scope, controllers

		scope

	registerProps = (def, template, managedProps, node, scope, repeated) ->
		while def?
			managedProps.forEach (name, idx) ->
				prop = def[name]
				if typeof prop == 'function'
					# register
					scope.$$watch interpolate(template[name]), (value) ->
						prop.call node, value, scope
					, repeated

					delete managedProps[idx]

			managedProps = _.compact managedProps
			def = dict[def.inherit]

	createNode_r = (template, scope, repeated) ->
		node_has_scope = true if template.controller?

		def = dict[template.type]
		throw "unsupported type : #{template.type}" unless def?

		# create a node
		unless def.cons_args? 
			node = do def.cons
		else
			initArgs = def.cons_args.map (arg) -> interpolate(template[arg])(scope)
			node = def.cons initArgs..., scope

		if template.show?
			fn = interpolate template.show
			scope.$$watch fn, (res) ->
				if res == true or res == 'true'
					node.setVisible true
				else
					node.setVisible false
			, repeated

		# .data (s) -
		# .

		if template.repeat?
			node.$$repeatedChildren = []
			text = template.repeat.bind.replace ',', ' '
			words = text.split(' ')
			words = _.compact words
			if words.length == 4
				itr = words[0]
				indexer = words[1]
				container = words[3]
			else if words.length == 3
				itr = words[0]
				indexer = null
				container = words[2]
			else
				throw "repeat usage wrong... (#{words}:not 3~4 words)"

			childTemplate = template.repeat.template
			push_action = slice_first_char(template.repeat.push_action)
			pop_action = slice_first_char(template.repeat.pop_action)
#			src = scope[container]
#			throw "no #{container} in the scope" unless src?

			# don't need to call interpolate function because it already interpolated...
			fn = makeFunc container
#			log 'my container : ' + container
#			log 'my fn : ' + String(fn)
			scope.$$watch fn, (list, prev_list) ->
				throw "invalid repeated list : #{list}" if not list?

				prev_list = [] if prev_list is null

				if list.length > prev_list.length
					# add exceeded elements
					for i in [prev_list.length...list.length]
						childScope = genScope scope
						childScope[itr] = list[i]
						childScope[indexer] = i if indexer?
						childNode = createNode_r childTemplate, childScope,
							itr: itr
							index: i
							container: container.slice(1, container.length)
						childNode.$$scope = childScope
						node.addChild childNode, (childTemplate.priority or 0)
						
						if push_action?
							action_func = scope[push_action]
							throw 'push action is not function' if typeof action_func != 'function'
							action_func childNode, i, (i-prev_list.length), (list.length-prev_list.length)
						# need assertion of perfect sync
						node.$$repeatedChildren.push childNode
				else if list.length < prev_list.length
					# delete fallen elements
					for i in [list.length...prev_list.length]
						childNode = node.$$repeatedChildren[i]
						after_work = ->
								childNode.removeFromParent()
								childNode.$$scope.$$removeFromParent()
						if pop_action?
							action_func = scope[pop_action]
							throw 'pop function is not function' if typeof action_func != 'function'
							action_func childNode, i, (i-list.length), (prev_list.length-list.length), ->
								do after_work
						else
							do after_work
					node.$$repeatedChildren = node.$$repeatedChildren.splice 0, list.length


		if template.children?
			template.children.forEach (child, index) ->
				if child.controller?
					childScope = _.find scope.$$childScopes, (s) ->
						s.$$controllerName == child.controller
					throw "can\'t find @{child.controller} controller" if childScope == null	
				else
					childScope = scope
				childNode = createNode_r child, childScope
				node.addChild childNode, (child.priority or 0)

		managedProps = getManagedProps template
		registerProps def, template, managedProps, node, scope, repeated

		node

	pub.make_view = (template, controllers) ->
		rootScope = createScope_r template, null, controllers
		rootNode = createNode_r template, rootScope
		rootScope.$apply -> # for initiation
		rootNode

	pub